Index: trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.Designer.cs	(revision 13024)
+++ trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.Designer.cs	(revision 13080)
@@ -20,5 +20,4 @@
 #endregion
 
-using System.Windows.Forms;
 
 namespace HeuristicLab.Scripting.Views {
@@ -47,13 +46,13 @@
     /// </summary>
     private void InitializeComponent() {
-      this.components = new System.ComponentModel.Container();
-      this.startStopButton = new System.Windows.Forms.Button();
       this.splitContainer2 = new System.Windows.Forms.SplitContainer();
       this.variableStoreView = new HeuristicLab.Scripting.Views.VariableStoreView();
       this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.executionTimeTextBox = new System.Windows.Forms.TextBox();
-      this.executionTimeLabel = new System.Windows.Forms.Label();
+      this.infoTabControl.SuspendLayout();
+      this.outputTabPage.SuspendLayout();
+      this.errorListTabPage.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
       this.splitContainer1.Panel1.SuspendLayout();
+      this.splitContainer1.Panel2.SuspendLayout();
       this.splitContainer1.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
@@ -64,34 +63,19 @@
       this.SuspendLayout();
       // 
-      // splitContainer1.Panel1
+      // executionTimeLabel
       // 
-      this.splitContainer1.Panel1.Controls.Add(this.executionTimeTextBox);
-      this.splitContainer1.Panel1.Controls.Add(this.executionTimeLabel);
-      this.splitContainer1.Panel1.Controls.SetChildIndex(this.executionTimeTextBox, 0);
-      this.splitContainer1.Panel1.Controls.SetChildIndex(this.executionTimeLabel, 0);
+      this.executionTimeLabel.Location = new System.Drawing.Point(394, 393);
+      // 
+      // executionTimeTextBox
+      // 
+      this.executionTimeTextBox.Location = new System.Drawing.Point(483, 390);
+      // 
+      // splitContainer1
+      // 
+      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
+      this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer1.Location = new System.Drawing.Point(0, 0);
       this.splitContainer1.Size = new System.Drawing.Size(637, 543);
-      // 
-      // nameTextBox
-      // 
-      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      this.nameTextBox.Location = new System.Drawing.Point(60, 0);
-      this.nameTextBox.Size = new System.Drawing.Size(750, 20);
-      // 
-      // infoLabel
-      // 
-      this.infoLabel.Location = new System.Drawing.Point(816, 4);
-      // 
-      // startStopButton
-      // 
-      this.startStopButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Play;
-      this.startStopButton.Location = new System.Drawing.Point(36, 26);
-      this.startStopButton.Name = "startStopButton";
-      this.startStopButton.Size = new System.Drawing.Size(24, 24);
-      this.startStopButton.TabIndex = 1;
-      this.startStopButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
-      this.toolTip.SetToolTip(this.startStopButton, "Run (F5)");
-      this.startStopButton.UseVisualStyleBackColor = true;
-      this.startStopButton.Click += new System.EventHandler(this.StartStopButtonOnClick);
+      this.splitContainer1.SplitterDistance = 427;
       // 
       // splitContainer2
@@ -114,9 +98,4 @@
       this.splitContainer2.SplitterDistance = 637;
       this.splitContainer2.TabIndex = 7;
-      //
-      // splitContainer1
-      //
-      this.splitContainer1.Location = new System.Drawing.Point(0, 0);
-      this.splitContainer1.Dock = DockStyle.Fill;
       // 
       // variableStoreView
@@ -145,30 +124,11 @@
       this.viewHost.ViewType = null;
       // 
-      // executionTimeTextBox
-      // 
-      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.executionTimeTextBox.Location = new System.Drawing.Point(483, 390);
-      this.executionTimeTextBox.Name = "executionTimeTextBox";
-      this.executionTimeTextBox.ReadOnly = true;
-      this.executionTimeTextBox.Size = new System.Drawing.Size(137, 20);
-      this.executionTimeTextBox.TabIndex = 17;
-      // 
-      // executionTimeLabel
-      // 
-      this.executionTimeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.executionTimeLabel.AutoSize = true;
-      this.executionTimeLabel.Location = new System.Drawing.Point(394, 393);
-      this.executionTimeLabel.Name = "executionTimeLabel";
-      this.executionTimeLabel.Size = new System.Drawing.Size(83, 13);
-      this.executionTimeLabel.TabIndex = 16;
-      this.executionTimeLabel.Text = "&Execution Time:";
-      // 
-      // ScriptView
+      // CSharpScriptView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Controls.Add(this.splitContainer2);
-      this.Controls.Add(this.startStopButton);
-      this.Name = "ScriptView";
-      this.Size = new System.Drawing.Size(835, 602);
+      this.Name = "CSharpScriptView";
+      this.Controls.SetChildIndex(this.infoTextLabel, 0);
+      this.Controls.SetChildIndex(this.compileButton, 0);
       this.Controls.SetChildIndex(this.startStopButton, 0);
       this.Controls.SetChildIndex(this.splitContainer2, 0);
@@ -176,8 +136,14 @@
       this.Controls.SetChildIndex(this.nameTextBox, 0);
       this.Controls.SetChildIndex(this.infoLabel, 0);
+      this.infoTabControl.ResumeLayout(false);
+      this.outputTabPage.ResumeLayout(false);
+      this.outputTabPage.PerformLayout();
+      this.errorListTabPage.ResumeLayout(false);
       this.splitContainer1.Panel1.ResumeLayout(false);
       this.splitContainer1.Panel1.PerformLayout();
+      this.splitContainer1.Panel2.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
       this.splitContainer1.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.splitContainer2.Panel1.ResumeLayout(false);
       this.splitContainer2.Panel2.ResumeLayout(false);
@@ -191,10 +157,7 @@
     #endregion
 
-    protected System.Windows.Forms.Button startStopButton;
     protected System.Windows.Forms.SplitContainer splitContainer2;
     protected MainForm.WindowsForms.ViewHost viewHost;
     protected VariableStoreView variableStoreView;
-    protected TextBox executionTimeTextBox;
-    protected Label executionTimeLabel;
   }
 }
Index: trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.cs
===================================================================
--- trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.cs	(revision 13024)
+++ trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.cs	(revision 13080)
@@ -21,9 +21,6 @@
 
 using System;
-using System.Drawing;
-using System.Threading;
 using System.Windows.Forms;
 using HeuristicLab.Common;
-using HeuristicLab.Common.Resources;
 using HeuristicLab.MainForm;
 
@@ -32,11 +29,5 @@
   [View("C# Script View")]
   [Content(typeof(CSharpScript), true)]
-  public partial class CSharpScriptView : ScriptView {
-    private const string ScriptExecutionStartedMessage = "Script execution started";
-    private const string ScriptExecutionCanceledMessage = "Script execution canceled";
-    private const string ScriptExecutionSuccessfulMessage = "Script execution successful";
-    private const string ScriptExecutionFailedMessage = "Script execution failed";
-
-    protected bool Running { get; set; }
+  public partial class CSharpScriptView : ExecutableScriptView {
 
     public new CSharpScript Content {
@@ -51,54 +42,13 @@
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.ScriptExecutionStarted += ContentOnScriptExecutionStarted;
-      Content.ScriptExecutionFinished += ContentOnScriptExecutionFinished;
       Content.ConsoleOutputChanged += ContentOnConsoleOutputChanged;
-      Content.ExecutionTimeChanged += ContentOnExecutionTimeChanged;
     }
 
     protected override void DeregisterContentEvents() {
-      Content.ScriptExecutionStarted -= ContentOnScriptExecutionStarted;
-      Content.ScriptExecutionFinished -= ContentOnScriptExecutionFinished;
       Content.ConsoleOutputChanged -= ContentOnConsoleOutputChanged;
-      Content.ExecutionTimeChanged -= ContentOnExecutionTimeChanged;
       base.DeregisterContentEvents();
     }
 
     #region Content event handlers
-    protected virtual void ContentOnScriptExecutionStarted(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke((Action<object, EventArgs>)ContentOnScriptExecutionStarted, sender, e);
-      else {
-        Locked = true;
-        ReadOnly = true;
-        startStopButton.Image = VSImageLibrary.Stop;
-        toolTip.SetToolTip(startStopButton, "Stop (Shift+F5)");
-        UpdateInfoTextLabel(ScriptExecutionStartedMessage, SystemColors.ControlText);
-        infoTabControl.SelectedTab = outputTabPage;
-      }
-    }
-    protected virtual void ContentOnScriptExecutionFinished(object sender, EventArgs<Exception> e) {
-      if (InvokeRequired)
-        Invoke((Action<object, EventArgs<Exception>>)ContentOnScriptExecutionFinished, sender, e);
-      else {
-        Locked = false;
-        ReadOnly = false;
-        startStopButton.Image = VSImageLibrary.Play;
-        toolTip.SetToolTip(startStopButton, "Run (F5)");
-
-        var ex = e.Value;
-        if (ex == null) {
-          UpdateInfoTextLabel(ScriptExecutionSuccessfulMessage, Color.DarkGreen);
-        } else if (ex is ThreadAbortException) {
-          // the execution was canceled by the user
-          UpdateInfoTextLabel(ScriptExecutionCanceledMessage, Color.DarkOrange);
-        } else {
-          UpdateInfoTextLabel(ScriptExecutionFailedMessage, Color.DarkRed);
-          PluginInfrastructure.ErrorHandling.ShowErrorDialog(this, ex);
-        }
-
-        Running = false;
-      }
-    }
     protected virtual void ContentOnConsoleOutputChanged(object sender, EventArgs<string> e) {
       if (InvokeRequired)
@@ -106,11 +56,4 @@
       else {
         outputTextBox.AppendText(e.Value);
-      }
-    }
-    protected virtual void ContentOnExecutionTimeChanged(object sender, EventArgs eventArgs) {
-      if (InvokeRequired)
-        Invoke((Action<object, EventArgs>)ContentOnExecutionTimeChanged, sender, eventArgs);
-      else {
-        executionTimeTextBox.Text = Content == null ? "-" : Content.ExecutionTime.ToString();
       }
     }
@@ -121,49 +64,8 @@
       if (Content == null) {
         variableStoreView.Content = null;
-        executionTimeTextBox.Text = "-";
       } else {
         variableStoreView.Content = Content.VariableStore;
-        executionTimeTextBox.Text = Content.ExecutionTime.ToString();
       }
     }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      startStopButton.Enabled = Content != null && (!Locked || Running);
-    }
-
-    protected virtual void StartStopButtonOnClick(object sender, EventArgs e) {
-      if (Running) {
-        Content.Kill();
-      } else
-        if (Compile()) {
-        outputTextBox.Clear();
-        Running = true;
-        Content.ExecuteAsync();
-      }
-    }
-
-    #region global HotKeys
-    protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
-      switch (keyData) {
-        case Keys.F5:
-          if (Content != null && !Locked && !Running) {
-            if (Compile()) {
-              outputTextBox.Clear();
-              Content.ExecuteAsync();
-              Running = true;
-            }
-          }
-          return true;
-        case Keys.F5 | Keys.Shift:
-          if (Running) Content.Kill();
-          return true;
-        case Keys.F6:
-          if (!Running) base.ProcessCmdKey(ref msg, keyData);
-          return true;
-      }
-      return base.ProcessCmdKey(ref msg, keyData);
-    }
-    #endregion
   }
 }
Index: trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.Designer.cs	(revision 13080)
+++ trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.Designer.cs	(revision 13080)
@@ -0,0 +1,116 @@
+﻿namespace HeuristicLab.Scripting.Views {
+  partial class ExecutableScriptView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.startStopButton = new System.Windows.Forms.Button();
+      this.executionTimeLabel = new System.Windows.Forms.Label();
+      this.executionTimeTextBox = new System.Windows.Forms.TextBox();
+      this.infoTabControl.SuspendLayout();
+      this.outputTabPage.SuspendLayout();
+      this.errorListTabPage.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
+      this.splitContainer1.Panel1.SuspendLayout();
+      this.splitContainer1.Panel2.SuspendLayout();
+      this.splitContainer1.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // splitContainer1.Panel1
+      // 
+      this.splitContainer1.Panel1.Controls.Add(this.executionTimeTextBox);
+      this.splitContainer1.Panel1.Controls.Add(this.executionTimeLabel);
+      this.splitContainer1.Panel1.Controls.SetChildIndex(this.executionTimeTextBox, 0);
+      this.splitContainer1.Panel1.Controls.SetChildIndex(this.executionTimeLabel, 0);
+      // 
+      // nameTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      // 
+      // startStopButton
+      // 
+      this.startStopButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Play;
+      this.startStopButton.Location = new System.Drawing.Point(36, 26);
+      this.startStopButton.Name = "startStopButton";
+      this.startStopButton.Size = new System.Drawing.Size(24, 24);
+      this.startStopButton.TabIndex = 10;
+      this.startStopButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
+      this.toolTip.SetToolTip(this.startStopButton, "Run (F5)");
+      this.startStopButton.UseVisualStyleBackColor = true;
+      this.startStopButton.Click += new System.EventHandler(this.startStopButton_Click);
+      // 
+      // executionTimeLabel
+      // 
+      this.executionTimeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.executionTimeLabel.AutoSize = true;
+      this.executionTimeLabel.Location = new System.Drawing.Point(589, 396);
+      this.executionTimeLabel.Name = "executionTimeLabel";
+      this.executionTimeLabel.Size = new System.Drawing.Size(83, 13);
+      this.executionTimeLabel.TabIndex = 18;
+      this.executionTimeLabel.Text = "&Execution Time:";
+      // 
+      // executionTimeTextBox
+      // 
+      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.executionTimeTextBox.Location = new System.Drawing.Point(678, 393);
+      this.executionTimeTextBox.Name = "executionTimeTextBox";
+      this.executionTimeTextBox.ReadOnly = true;
+      this.executionTimeTextBox.Size = new System.Drawing.Size(137, 20);
+      this.executionTimeTextBox.TabIndex = 19;
+      // 
+      // ExecutableScriptView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.startStopButton);
+      this.Name = "ExecutableScriptView";
+      this.Controls.SetChildIndex(this.infoTextLabel, 0);
+      this.Controls.SetChildIndex(this.compileButton, 0);
+      this.Controls.SetChildIndex(this.splitContainer1, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.infoLabel, 0);
+      this.Controls.SetChildIndex(this.startStopButton, 0);
+      this.infoTabControl.ResumeLayout(false);
+      this.outputTabPage.ResumeLayout(false);
+      this.outputTabPage.PerformLayout();
+      this.errorListTabPage.ResumeLayout(false);
+      this.splitContainer1.Panel1.ResumeLayout(false);
+      this.splitContainer1.Panel1.PerformLayout();
+      this.splitContainer1.Panel2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
+      this.splitContainer1.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Button startStopButton;
+    protected System.Windows.Forms.Label executionTimeLabel;
+    protected System.Windows.Forms.TextBox executionTimeTextBox;
+  }
+}
Index: trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.cs
===================================================================
--- trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.cs	(revision 13080)
+++ trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.cs	(revision 13080)
@@ -0,0 +1,152 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using System.Threading;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.Common.Resources;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Scripting.Views {
+  [View("Executable Script View")]
+  [Content(typeof(ExecutableScript), true)]
+  public partial class ExecutableScriptView : ScriptView {
+    private const string ScriptExecutionStartedMessage = "Script execution started";
+    private const string ScriptExecutionCanceledMessage = "Script execution canceled";
+    private const string ScriptExecutionSuccessfulMessage = "Script execution successful";
+    private const string ScriptExecutionFailedMessage = "Script execution failed";
+
+    protected bool Running {
+      get { return Content.Running; }
+    }
+
+    public new ExecutableScript Content {
+      get { return (ExecutableScript)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public ExecutableScriptView() {
+      InitializeComponent();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ScriptExecutionStarted += ContentOnScriptExecutionStarted;
+      Content.ScriptExecutionFinished += ContentOnScriptExecutionFinished;
+      Content.ExecutionTimeChanged += ContentOnExecutionTimeChanged;
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.ScriptExecutionStarted -= ContentOnScriptExecutionStarted;
+      Content.ScriptExecutionFinished -= ContentOnScriptExecutionFinished;
+      Content.ExecutionTimeChanged -= ContentOnExecutionTimeChanged;
+      base.DeregisterContentEvents();
+    }
+
+    #region Event Handlers
+    protected virtual void ContentOnScriptExecutionStarted(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke((Action<object, EventArgs>)ContentOnScriptExecutionStarted, sender, e);
+      else {
+        Locked = true;
+        ReadOnly = true;
+        startStopButton.Image = VSImageLibrary.Stop;
+        toolTip.SetToolTip(startStopButton, "Stop (Shift+F5)");
+        UpdateInfoTextLabel(ScriptExecutionStartedMessage, SystemColors.ControlText);
+        infoTabControl.SelectedTab = outputTabPage;
+      }
+    }
+    protected virtual void ContentOnScriptExecutionFinished(object sender, EventArgs<Exception> e) {
+      if (InvokeRequired)
+        Invoke((Action<object, EventArgs<Exception>>)ContentOnScriptExecutionFinished, sender, e);
+      else {
+        Locked = false;
+        ReadOnly = false;
+        startStopButton.Image = VSImageLibrary.Play;
+        toolTip.SetToolTip(startStopButton, "Run (F5)");
+
+        var ex = e.Value;
+        if (ex == null) {
+          UpdateInfoTextLabel(ScriptExecutionSuccessfulMessage, Color.DarkGreen);
+        } else if (ex is ThreadAbortException) {
+          // the execution was canceled by the user
+          UpdateInfoTextLabel(ScriptExecutionCanceledMessage, Color.DarkOrange);
+        } else {
+          UpdateInfoTextLabel(ScriptExecutionFailedMessage, Color.DarkRed);
+          PluginInfrastructure.ErrorHandling.ShowErrorDialog(this, ex);
+        }
+      }
+    }
+    protected virtual void ContentOnExecutionTimeChanged(object sender, EventArgs eventArgs) {
+      if (InvokeRequired)
+        Invoke((Action<object, EventArgs>)ContentOnExecutionTimeChanged, sender, eventArgs);
+      else {
+        executionTimeTextBox.Text = Content == null ? "-" : Content.ExecutionTime.ToString();
+      }
+    }
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        executionTimeTextBox.Text = "-";
+      } else {
+        executionTimeTextBox.Text = Content.ExecutionTime.ToString();
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      startStopButton.Enabled = Content != null && (!Locked || Running);
+    }
+
+    protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
+      switch (keyData) {
+        case Keys.F5:
+          if (Content != null && !Locked && !Running) {
+            if (Compile()) {
+              outputTextBox.Clear();
+              Content.ExecuteAsync();
+            }
+          }
+          return true;
+        case Keys.F5 | Keys.Shift:
+          if (Running) Content.Kill();
+          return true;
+        case Keys.F6:
+          if (!Running) base.ProcessCmdKey(ref msg, keyData);
+          return true;
+      }
+      return base.ProcessCmdKey(ref msg, keyData);
+    }
+
+    private void startStopButton_Click(object sender, EventArgs e) {
+      if (Running) {
+        Content.Kill();
+      } else if (Compile()) {
+        outputTextBox.Clear();
+        Content.ExecuteAsync();
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Scripting.Views/3.3/HeuristicLab.Scripting.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Scripting.Views/3.3/HeuristicLab.Scripting.Views-3.3.csproj	(revision 13024)
+++ trunk/sources/HeuristicLab.Scripting.Views/3.3/HeuristicLab.Scripting.Views-3.3.csproj	(revision 13080)
@@ -97,4 +97,10 @@
     <Compile Include="CSharpScriptView.Designer.cs">
       <DependentUpon>CSharpScriptView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="ExecutableScriptView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ExecutableScriptView.Designer.cs">
+      <DependentUpon>ExecutableScriptView.cs</DependentUpon>
     </Compile>
     <Compile Include="ScriptView.cs">